<?php
include("api.php"); // Ensure this includes your database connection setup
header('Content-Type: application/json');

// Get the device ID from the request
$deviceId = isset($_GET['deviceid']) ? $_GET['deviceid'] : '';

$fcmUpdate = ""; // Initialize fcmUpdate variable

if (!empty($deviceId)) {
    // Prepare and execute the SQL query to get the fcm_date for the deviceid
    $sql = "SELECT fcm_date FROM fcmtoken WHERE device_id = ?";
    $stmt = mysqli_prepare($conn, $sql);
    mysqli_stmt_bind_param($stmt, 's', $deviceId);
    mysqli_stmt_execute($stmt);
    $result = mysqli_stmt_get_result($stmt);

    // Check if fcm_date was found
    if ($result && mysqli_num_rows($result) > 0) {
        $row = mysqli_fetch_assoc($result);
        $fcmdate = $row['fcm_date'];
        $fcmUpdate = " AND created_at >= '$fcmdate'";
    } else {
        echo json_encode([]);
        mysqli_close($conn);
        exit();
    }

    mysqli_stmt_close($stmt);
}

// Prepare the SQL query for notifications
$sql = "SELECT title AS noti_title, image_default AS noti_image, id AS noti_id, created_at AS noti_time 
        FROM posts 
        WHERE is_notification = 3 $fcmUpdate 
        ORDER BY created_at DESC LIMIT 25";

$result = mysqli_query($conn, $sql);

$notifications = [];

if ($result && mysqli_num_rows($result) > 0) {
    while ($row = mysqli_fetch_assoc($result)) {
        $notifications[] = $row;
    }
}

// Output the results as JSON
echo json_encode($notifications);

mysqli_close($conn);
?>
