<?php
require 'vendor/autoload.php';
use Google\Auth\Credentials\ServiceAccountCredentials;
use Google\Auth\HttpHandler\HttpHandlerFactory;

class Database {
    private $dsn = 'mysql:host=localhost;dbname=kumudamnewscp_db';
    private $username = 'kumudamnewscp_usr';
    private $password = 'hMA{k{Zua*7Z';
    public $pdo;

    public function __construct() {
        try {
            $this->pdo = new PDO($this->dsn, $this->username, $this->password);
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (PDOException $e) {
            die('Connection failed: ' . $e->getMessage());
        }
    }
}

class NotificationService {

    private $fcmUrl = "https://fcm.googleapis.com/v1/projects/kumudam-9bd1f/messages:send";
    private $serviceAccountKeyFile = "pvk.json";
    private $accessToken;
    private $db;

    public function __construct() {
        $this->initializeCredentials();
        $this->db = new Database(); // Initialize the Database
    }

    // Initialize credentials and fetch the access token
    private function initializeCredentials() {
        $credential = new ServiceAccountCredentials(
            "https://www.googleapis.com/auth/firebase.messaging",
            json_decode(file_get_contents($this->serviceAccountKeyFile), true)
        );
        
        $this->accessToken = $credential->fetchAuthToken(HttpHandlerFactory::build())['access_token'];
    }

    // Function to send FCM notification to multiple tokens
    private function fcmNotification($title, $tokens, $image, $body, $postId, $link) {
        
        
        foreach ($tokens as $fcmtoken) {
            $payload = json_encode([
                "message" => [
                    //"topic" => "knews_topic", 
                    "token" => "$fcmtoken",
                    "notification" => [
                        "title" => $title,
                        "body" => $body,
                        "image" => $image
                    ],
                    "data" => [
                        "postId" => "$postId",
                        "link" => $link
                    ],
                    "webpush" => [
                        "fcm_options" => [
                            "link" => $link
                        ]
                    ]
                ]
            ]);

            // Prepare the cURL request
            $ch = curl_init($this->fcmUrl);
            curl_setopt($ch, CURLOPT_HTTPHEADER, [
                'Content-Type: application/json',
                'Authorization: Bearer ' . $this->accessToken
            ]);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

            // Execute cURL request and get response
            $response = curl_exec($ch);

            // Check for errors
            if (curl_errno($ch)) {
                echo 'Error: ' . curl_error($ch);
            } else {
                  'Response: ' . $response;
            }

            // Close the cURL session
            curl_close($ch);
        }
    }

    // Function to send notification by fetching tokens from the `fcmtoken` table
    public function sendNotification($title, $image, $body, $postId, $link) {
        // Fetch FCM tokens from the `fcmtoken` table where `noti_status` is 'Yes'
        $stmt = $this->db->pdo->query("SELECT fcm_token FROM fcmtoken WHERE noti_status = 'Yes'");
        $tokens = $stmt->fetchAll(PDO::FETCH_COLUMN);

        // If there are tokens, send the notification
        if (!empty($tokens)) {
            $this->fcmNotification($title, $tokens, $image, $body, $postId, $link);
        } else {
            echo 'No tokens found';
        }
    }

    // Function to process notifications for posts
    public function processNotifications() {
        try {
            // Fetch posts that need notifications
            $stmt = $this->db->pdo->query("SELECT * FROM posts WHERE is_notification = '2' ORDER BY created_at DESC LIMIT 1");

            while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
                $postId = $row['id'];
                $title = $row['title'];
                $body = "";   
                $image = "https://kumudamnews.com/".$row['image_default'];
                $link = "https://kumudamnews.com/";

                // Send notification
                $this->sendNotification($title, $image, $body, $postId, $link);

                // Update status to '3' after sending notification
                $updateStmt = $this->db->pdo->prepare("UPDATE posts SET is_notification = '3' WHERE id = ?");
                $updateStmt->execute([$postId]);
            }

        } catch (PDOException $e) {
            echo 'Failed to process notifications: ' . $e->getMessage();
        }
    }
}

// Usage example
$notificationService = new NotificationService();
$notificationService->processNotifications();
